#include "ados.h"
#include "standard.h"

/************************************************************************
 * NAME:	ados33_dir_report()
 *
 * DESCR:	Generate a pretty directory listing. 
 *
 * ARGS:	
 *
 * RETURNS:	
 *
 * NOTES:	
 ************************************************************************/

ados33_dir_report(struct adosfs *adosfs, int verbosity)
{
    int		sectors_free;
    int		bytes_free;
/**
/**    ados_allocation_print(adosfs);	/* debugging only	*/
/**/
    
    ados_catalog_report(adosfs->catalog,verbosity);

    sectors_free = ados_vtoc_free_count(adosfs->vtoc);
    bytes_free = sectors_free * adosfs->vtoc->sector_size;
    printf("Free space: %d sector%s (%s%dk)\n",
	   sectors_free, (sectors_free==1)?"":"s",
	   (bytes_free < 1024 && bytes_free!= 0)?".":"",
	   (bytes_free < 1024)?bytes_free/100:bytes_free/1024);

    return;
}
